//----------------------------------------------------------------------------------------// 
// +-------------------------------------------------------------------------------------+ //
// |                                                                                     | //
// |                                    Trend Scalper                                    | //
// |                             Timeframe = 1 Hr., EURJPY                               | //
// |                                                                                     | //
// +-------------------------------------------------------------------------------------+ //
//-----------------------------------------------------------------------------------------// 

/*

Revision
========
v1  - Original version (pending straddle), when buy or sell triggered opposite pending order deleted.
Changed lotmm to /100 instead of /10.
*/

#property copyright "Copyright  2009, Forex"

extern string  Expert_Name          = "TS v1.0"; // Straddle version with expiry
extern int     Magic_Number         = 1110;
extern int     MagicSeed            = 1;
extern int     Candles_for_Stop     = 8; 
extern int     Candles_for_Entry    = 8; 
extern double  Pending_Pips_Buy     = 9;
extern double  Pending_Pips_Sell    = 9;
extern double  Stoploss_Offset_Pips = 5;
extern bool    ManageMoney          = true;
extern int     Risk                 = 5;
extern double  Lots                 = 0.05;
extern double  BuyTake_Profit       = 15;
extern double  SellTake_Profit      = 15;
extern bool    UseSound             = false;  
extern bool    StopLoss             = true;
extern bool    ProfitTrailing       = true;  
extern bool    TakeProfit           = true;
extern int     TrailingStop         = 100;   
extern int     TrailingStep         = 2;   
string         NameFileSound        = "expert.wav";  
extern string  Pending_Orders       = "== Number of hours for pending order to expire =="; 
extern int     Pending_Order_Expiry = 8; // Bars to expire after pending order placed  

static bool    Indicator_Control    = 0;
       int     MaxTrades            = 1;

int BuyStopOrders[50]; 
int SellStopOrders[50]; 
int pending_orders_count = 0; 

#include <OrderReliable_V0_2_5.mqh> // Place in /experts/include folder

void DeleteArrayElement (int &array[], int index) {

      for(int i = index; i<pending_orders_count-1; i++) {
      
         array[i] = array[i+1];
      
      }           
      
}

void DeleteObsoletePendingOrders() {

int i; 
/*  
   
   
   string ids = ""; 
   
   if (pending_orders_count >0) {
   for(i=0; i<pending_orders_count; i++) {
      ids = ids + "( "+BuyStopOrders[i]+","+SellStopOrders[i]+" )";
   } 
   
    Print("DeleteObsoletePendingOrders.  Pairs:", pending_orders_count, " {", ids, "}"); 
   }
   i=0; 
   
*/   
   while(i<pending_orders_count) {
   
      int bticket = BuyStopOrders[i];
      int sticket = SellStopOrders[i];
      //Print ("Processing pair: (",bticket ,", ",sticket, ")" );
      if (OrderSelect(bticket,SELECT_BY_TICKET,MODE_TRADES)){      
      // Order found and selected
      // Check if it is opened
      //Print("bticket #", bticket, " found" );
         if (OrderType() == OP_BUY) {
            // Delete oposite
            OrderDelete(SellStopOrders[i]);

            // Remove both orders from queue
            DeleteArrayElement(BuyStopOrders, i); 
            DeleteArrayElement(SellStopOrders, i); 
            pending_orders_count--;       
            continue;     
            
         }              
      } else {
      // Order is not found
      //   delete opposite order

            // Delete oposite
            OrderDelete(sticket);
//            Print ("Order with #", bticket, "not found");

            // Remove both orders from queue
            DeleteArrayElement(BuyStopOrders, i); 
            DeleteArrayElement(SellStopOrders, i);    
            pending_orders_count--;         
            continue;      
      
      }
      
      // The same for SELLSTOP 
      
      if (OrderSelect(sticket,SELECT_BY_TICKET,MODE_TRADES)){      
      // Order found and selected
      // Check if it is opened
//      Print("sticket #", sticket, " found" );
         if (OrderType() == OP_SELL) {
            // Delete oposite
            OrderDelete(bticket);

            // Remove both orders from queue
            DeleteArrayElement(BuyStopOrders, i); 
            DeleteArrayElement(SellStopOrders, i);   
            pending_orders_count--;          
            continue;            
         }              
      } else {
      // Order is not found
      //   delete opposite order
            //Print ("Order with #", sticket, "not found");
            
            // Delete oposite
            OrderDelete(bticket);

            // Remove both orders from queue
            DeleteArrayElement(BuyStopOrders, i); 
            DeleteArrayElement(SellStopOrders, i);             
            pending_orders_count--;   
            continue;
      
      }
      
      //if ( ( bticket == BuyStopOrders[i]) && ( sticket == SellStopOrders[i]) )
         i++;       
   
   
   }
   
}


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }


//--------------------------------------------------------------------------------------// 

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && Magic_Number==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

//--------------------------------------------------------------------------------------// 

int start(){

// Call this function on each tick
DeleteObsoletePendingOrders();

HideTestIndicators(Indicator_Control);


int expire=TimeCurrent()+Pending_Order_Expiry*60*60;


 for (int i=0; i<OrdersTotal(); i++) 
  {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
    {
           if(OrderType()==OP_SELLSTOP)
         {
//         OrderDelete(OrderTicket());
//         OrderSendReliable(Symbol(),OP_BUY,Lots,Ask,5,Ask-(99*Point),Ask-(30*Point),cmt,IDT,2,Red);
         }

           if(OrderType()==OP_BUYSTOP)
         {
//         OrderDelete(OrderTicket());
         }
      TrailingPositions();
    }
  }

   if(orderscnt()<MaxTrades)
   {
      if(ManageMoney==true) Lots = LotSize();
      if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);
      CheckOpen();
      
   }   
}

//--------------------------------------------------------------------------------------// 

void CheckOpen(){
 
   bool Buy, Sell;
   
   string cmt=Expert_Name+","+Symbol()+","+Period();

// ***
   
   double Buy_Price  = (High[iHighest(NULL,0,MODE_HIGH,Candles_for_Entry,1)]) + (Pending_Pips_Buy*Point);
   double Sell_Price = (Low[iLowest(NULL,0,MODE_LOW,Candles_for_Entry,1)]) - (Pending_Pips_Sell*Point);

   double Buy_Take_Profit  = (Buy_Price + (BuyTake_Profit*Point));
   double Sell_Take_Profit = (Sell_Price - (SellTake_Profit*Point));

   double Buy_StopLoss  = (Low[iLowest(NULL,0,MODE_LOW,Candles_for_Stop,1)]) - (Stoploss_Offset_Pips*Point);
   double Sell_StopLoss = (High[iHighest(NULL,0,MODE_HIGH,Candles_for_Stop,1)]) + (Stoploss_Offset_Pips*Point);   

// ***** START OF INDICATORS  ***** 

double hist1 = iOsMA(NULL,0,12,26,9,PRICE_CLOSE,1);
double hist2 = iOsMA(NULL,0,12,26,9,PRICE_CLOSE,2);
double hist3 = iOsMA(NULL,0,12,26,9,PRICE_CLOSE,3);

// ***** END OF INDICATORS  *****


// *****  START of BUY and SELL CONDITION  *****

double a  = hist1 > 0.020;
double b  = hist2 < 0.020;
double c  = (hist1 > 0) && (hist2 > 0) ;

double aa  = hist1 < -0.020;
double bb  = hist2 > -0.020;
double cc  = (hist1 < 0) && (hist2 < 0) ;

double Buy1   = (a && b && c);

double Sell1  = (aa && bb && cc);

// *****  END of BUY and SELL CONDITION  *****

Buy = False;
if (Buy1||Buy1)
Buy = True;

Sell = False;
if (Sell1||Sell1)
Sell = True;
  
   double TP,SL;
   
   Comment
   (
   
   "\n " + Expert_Name + ",   Magic Number = " + Magic_Number + 
   "\n ==========================" + 
   "\n Current Spread :  ", MarketInfo(Symbol(),MODE_SPREAD),   " pips",
   "\n Trade size: ", Lots, " Lots",   
   "\n Value per pip = $",MarketInfo(Symbol(), MODE_TICKVALUE)*Lots
    
    );

   
   Sell_Price = NormalizeDouble( Sell_Price, 4);
   Buy_Price = NormalizeDouble( Buy_Price, 4); 
   Buy_StopLoss = NormalizeDouble( Buy_StopLoss, 4);
   Buy_Take_Profit = NormalizeDouble( Buy_Take_Profit, 4);
   Sell_StopLoss = NormalizeDouble( Sell_StopLoss, 4);
   Sell_Take_Profit = NormalizeDouble( Sell_Take_Profit, 4); 
   datetime expire=TimeCurrent()+Pending_Order_Expiry*60*60;

 
//--------------------------------------------------------------------------------------// 
   if (Buy){
   

      if(StopLoss==0){SL=0;}else{SL=Buy_StopLoss; }
      if(TakeProfit==0){TP=0;}else{TP=Buy_Take_Profit;}

         if(orderscnt()+2 <= 2*MaxTrades)
            {
               int buystop_ticket = OrderSend(Symbol(),OP_BUYSTOP,Lots,Buy_Price,5,Buy_StopLoss,Buy_Take_Profit,cmt,Magic_Number,expire,LawnGreen); 
               int sellstop_ticket = OrderSend(Symbol(),OP_SELLSTOP,Lots,Sell_Price,1,Sell_StopLoss,Sell_Take_Profit,cmt,Magic_Number,expire,HotPink); 

//int sellstop_ticket = 0;               
               
          //     Print("OrderSend: ", Symbol(), "|",OP_SELLSTOP, "|",Lots, "|",Sell_Price, "|",1, "|",Sell_StopLoss, "|",TP, "|",cmt, "|",Magic_Number, "|",0,HotPink); 
             
               // Place a pair of orders in orders list               
                    if ( ( buystop_ticket>0 ) && 
                         (sellstop_ticket>0 ) ) {
            
                           BuyStopOrders[pending_orders_count] = buystop_ticket; 
                           SellStopOrders[pending_orders_count]= sellstop_ticket; 
                           pending_orders_count++; 
 
                     }
            }
 
   }
   if (Sell){

   
      if(StopLoss==0){SL=0;}else{SL= Sell_StopLoss;}
      if(TakeProfit==0){TP=0;}else{TP=Sell_Take_Profit;}

          if( orderscnt()+2 <= 2*MaxTrades)
            {
               sellstop_ticket = OrderSend(Symbol(),OP_SELLSTOP,Lots,Sell_Price,5,Sell_StopLoss,Sell_Take_Profit,cmt,Magic_Number,expire,HotPink); 
               buystop_ticket =  OrderSend(Symbol(),OP_BUYSTOP, Lots,Buy_Price, 1,Buy_StopLoss,Buy_Take_Profit,cmt,Magic_Number,expire,LawnGreen); 

//buystop_ticket = 0;
               
          //     Print("OrderSend: ",Symbol(),OP_BUYSTOP, "|", Lots, "|", Buy_Price, "|",  1, "|", SL, "|", TP, "|", cmt, "|", Magic_Number, "|", 0, LawnGreen); 
             }
 
               // Place a pair of orders in orders list               
                    if ( ( buystop_ticket>0 ) && 
                         (sellstop_ticket>0 ) ) {
            
                           BuyStopOrders[pending_orders_count] = buystop_ticket; 
                           SellStopOrders[pending_orders_count]= sellstop_ticket; 
                           pending_orders_count++; 
 
                     }
            }     
 
}
//--------------------------------------------------------------------------------------// 
double LotSize(){
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 1000)/100;  
   if (lotMM < 0.01) lotMM = Lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 50) lotMM = 50;
   return (lotMM);
} 
//--------------------------------------------------------------------------------------// 
void TrailingPositions() 
  {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) 
  {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) 
    {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) 
      {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) 
  {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) 
    {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) 
      {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}
//--------------------------------------------------------------------------------------// 
void ModifyStopLoss(double ldStopLoss)

 {
  bool fm;

  fm=OrderModifyReliable(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,Yellow);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//--------------------------------------------------------------------------------------// 



